=== debian/changelog ===
curl (8.14.1-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2117511). Remaining changes:
    - d/{control,rules}: drop nghttp3 and ngtcp2 dependencies in universe
    - d/{control,rules}: do not use gnutls for the curl binary
    - debian/control: don't build-depend on python3-impacket and stunnel4 on i386

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Tue, 22 Jul 2025 08:58:22 -0700

curl (8.14.1-2) unstable; urgency=medium

  * gbp pq import/export: Updated hunks offsets
  * d/patches:
    - tool_getparam_fix_ftp_pasv.patch: New upstream patch to fix regression
      in --ftp-pasv
    - curl_path_make_SFTP_handle_a_path.patch: New patch to fix longstanding
      regression on paths /~ for SFTP
    - tool_operate_fix_return_code_when_retry_is_used_but_not_triggered.patch:
      New patch to fix regression from 8.14.1

 -- Samuel Henrique <samueloph@debian.org>  Wed, 11 Jun 2025 19:18:58 +0100

curl (8.14.1-1ubuntu3) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 28 Aug 2025 19:13:38 +0000

curl (8.14.1-1ubuntu2) questing; urgency=medium

  * Drop part of delta as it was merged upstream:
    - d/rules: use libssh2-dev as it is in main (LP #2076865)

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Mon, 16 Jun 2025 12:40:58 -0700

curl (8.14.1-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2113994). Remaining changes:
    - d/rules: use libssh2-dev as it is in main (LP #2076865)
    - d/{control,rules}: drop nghttp3 and ngtcp2 dependencies in universe
    - d/{control,rules}: do not use gnutls for the curl binary
    - debian/control: don't build-depend on python3-impacket and stunnel4 on i386

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Wed, 11 Jun 2025 13:36:53 -0700

curl (8.14.1-1) unstable; urgency=medium

  * New upstream version 8.14.1
    - Fix CVE-2025-5399: WebSocket endless loop
  * d/p/multi_fix_add_handle_resizing: Drop patch, merged in 8.14.1

 -- Samuel Henrique <samueloph@debian.org>  Wed, 04 Jun 2025 08:21:05 +0100

curl (8.14.0-1) unstable; urgency=medium

  * New upstream version 8.14.0
  * Drop vendored wcurl now that it's in the upstream tarball
  * d/copyright: Update for upstream moved files:
    - They were moved from lib/ to lib/curlx/:
       ~ lib/curlx/version_win32.c
       ~ lib/curlx/version_win32.h
       ~ lib/curlx/inet_pton.c
  * d/patches:
    - Refresh patches
    - ZZZgnutls-build.patch: Update to also work with tests/tunit makefile
    - multi_fix_add_handle_resizing.patch: New patch to fix regression
    - Drop patches merged upstream:
      ~ autotools_install_shell_completion_files_on_cross_build.patch
      ~ scripts_completion_pl_sort_the_completion_file_for_all_shells.patch

 -- Samuel Henrique <samueloph@debian.org>  Wed, 28 May 2025 19:26:28 +0100

curl (8.13.0-5ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2111373). Remaining changes:
    - d/rules: use libssh2-dev as it is in main (LP #2076865)
    - d/{control,rules}: drop nghttp3 and ngtcp2 dependencies in universe
    - d/{control,rules}: do not use gnutls for the curl binary
    - debian/control: don't build-depend on python3-impacket and stunnel4 on i386

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Sun, 18 May 2025 19:46:02 -0700

curl (8.12.1-3ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - debian/control: Don't build-depend on python3-impacket and stunnel4 on
      i386 so we can drop it (and its dependencies) from the i386 partial port.
    - d/{control,rules}: Do not use gnutls for the curl binary.
    - d/{control,rules}: Drop nghttp3 and ngtcp2 dependencies in Universe.
    - d/rules: Use libssh2-dev as it is in Main (LP: #2076865).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Mar 2025 20:32:39 -0600

curl (8.12.1-2ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - debian/control: Don't build-depend on python3-impacket and stunnel4 on
      i386 so we can drop it (and its dependencies) from the i386 partial port.
    - d/{control,rules}: Do not use gnutls for the curl binary.
    - d/{control,rules}: Drop nghttp3 and ngtcp2 dependencies in Universe.
    - d/rules: Use libssh2-dev as it is in Main (LP: #2076865).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 19 Feb 2025 02:06:13 -0600

curl (8.12.1-1ubuntu2) plucky; urgency=medium

  * Disable valgrind on riscv64.
  * Drop libcurl4-openssl-dev's runtime dependency on libnghttp3-dev in
    Universe.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 18 Feb 2025 01:47:49 -0600

curl (8.12.1-1ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - debian/control: Don't build-depend on python3-impacket and stunnel4 on
      i386 so we can drop it (and its dependencies) from the i386 partial port.
      It's only used for the tests, which do not block the build in any case.
    - d/{control,rules}: Do not use gnutls for the curl binary.
    - d/{control,rules}: Drop nghttp3 & ngtcp2 depdendencies of
      libcurl-gnutls to avoid component-mismatch.
    - d/rules: Use libssh2-dev as it is in main (LP: #2076865).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 14 Feb 2025 21:43:29 -0600

curl (8.12.0+git20250209.89ed161+ds-1ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - debian/control: Don't build-depend on python3-impacket and stunnel4 on
      i386 so we can drop it (and its dependencies) from the i386 partial port.
      It's only used for the tests, which do not block the build in any case.
    - d/{control,rules}: Do not use gnutls for the curl binary.
    - d/{control,rules}: Drop nghttp3 & ngtcp2 depdendencies of
      libcurl-gnutls to avoid component-mismatch.
    - d/rules: Use libssh2-dev as it is in main (LP: #2076865).


